#include <stdlib.h>

#include "ComicFinder.hpp"

JNIEXPORT bool JNICALL Java_com_example_comicfinder_MainActivity_processImage
    (JNIEnv *env, jobject me, jbyteArray src, jintArray dst, jint width, jint height)
{
    unsigned char *p_src = reinterpret_cast<unsigned char *>(env->GetPrimitiveArrayCritical(src, NULL));
    if (NULL == p_src) {
        return false;
    }

    unsigned char *p_dst = reinterpret_cast<unsigned char *>(env->GetPrimitiveArrayCritical(dst, NULL));
    if (NULL == p_dst) {
        env->ReleasePrimitiveArrayCritical(src, p_src, 0);
        return false;
    }

    for (int k = 0; k < width*height; k++) {
        p_dst[k*4+0] = p_dst[k*4+1] = p_dst[k*4+2] = p_src[k];
        p_dst[k*4+3] = 0xff;
    }

    env->ReleasePrimitiveArrayCritical(dst, p_dst, 0);
    env->ReleasePrimitiveArrayCritical(src, p_src, 0);

    return true;
}
